<template>
  <view-new
    :status="status"
    title="Nowa operację"
    sentTitle="Nowa operacja została dodana"
    :back="BACK"
  >
    <input-form v-on:submit.prevent="on_submit">
      <input-dynamic-select
        :error="get_error_for('item')"
        v-model="item"
        name="Element wyposażenia"
        :list="items"
        size="2"
      />
      <input-dynamic-select
        :error="get_error_for('location')"
        v-model="location"
        name="Lokalizacja"
        :list="locations"
        size="2"
      />
      <input-dynamic-select
        :error="get_error_for('from')"
        v-model="from"
        name="Osoba wydająca"
        :list="users"
      />
      <input-dynamic-select
        :error="get_error_for('to')"
        v-model="to"
        name="Osoba przyjmująca"
        sentTitle=""
        :list="users"
      />
      <input-text-area
        :error="get_error_for('description')"
        v-model="description"
        name="Opis"
        size="2"
      />
      <div
        v-for="error in errors.filter((e) => e.field == null)"
        :style="{ gridColumnEnd: `span 2` }"
        :key="error.error"
        class="error"
      >
        {{ error.error }}
      </div>
      <input-button
        text="Dodaj operację"
        :spinner="status == formStatus.sending"
        size="2"
      />
    </input-form>
  </view-new>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import NewRecord from "@/views/new-views/NewRecord.ts";

import InputButton from "@/components/input/InputButton.vue";
import InputForm from "@/components/input/InputForm.vue";
import InputTextField from "@/components/input/InputTextField.vue";
import InputTextArea from "@/components/input/InputTextArea.vue";
import InputRadio from "@/components/input/InputRadio.vue";
import InputDynamicSelect from "@/components/input/select/InputDynamicSelect.vue";

import {
  NewActionData,
  DataId,
  UserData,
  LocationData,
  ItemData,
  NewUserData,
  ActionData,
} from "@/interfaces";

import ViewNew from "@/views/new-views/ViewNew.vue";
import { NApi, NApiError, QueryFilter } from "@/interfaces/connector";

@Options({
  components: {
    ViewNew,
    InputButton,
    InputForm,
    InputTextField,
    InputRadio,
    InputDynamicSelect,
    InputTextArea,
  },
  watch: {
    item: [
      {
        handler: "onItemChanged",
        immediate: false,
        deep: false,
      },
    ],
  },
})
export default class NewAction
  extends NewRecord<NewActionData, null>
  implements NewActionData {
  public API_CALL = NApi.newAction;
  public BACK = "/operacje";

  public from = 0;
  public to = 0;
  public location = 0;
  public item = 0;
  public description = "";

  public locations: { id: number; display_name: string }[] = [];
  public users: { id: number; display_name: string }[] = [];
  public items: { id: number; display_name: string }[] = [];

  public mounted() {
    this.load();
  }

  public async onItemChanged(val: number, oldVal: number): Promise<void> {
    try {
      const action: ActionData | undefined = (
        await NApi.getActions(new QueryFilter().isEqual("item_id", val))
      )[0];

      if (action.to?.id != undefined) {
        this.from = action.to?.id;
      }
    } catch (e) {
      console.error(e);
    }
  }

  public load = async () => {
    await Promise.all([
      this.load_users(),
      this.load_locations(),
      this.load_items(),
    ]);
  };

  public load_users = async () => {
    try {
      const data: UserData[] = await NApi.getUsers();

      for (const { id, name, surname } of data) {
        this.users.push({
          id,
          display_name: `${name} ${surname}`,
        });
      }
    } catch (e) {
      console.log(e);
    }
  };

  public load_locations = async () => {
    try {
      const data: LocationData[] = await NApi.getLocations();

      for (const { id, name, type, street } of data) {
        this.locations.push({
          id,
          display_name: `${name} ${street} (${type})`,
        });
      }
    } catch (e) {
      console.log(e);
    }
  };

  public load_items = async () => {
    try {
      const data: ItemData[] = await NApi.getItems();

      for (const { id, name, serial_number, part_number } of data) {
        this.items.push({
          id,
          display_name: `${name} (p/n: ${part_number} s/n: ${serial_number})`,
        });
      }
    } catch (e) {
      console.log(e);
    }
  };

  public get_data = () => ({
    from: this.from,
    to: this.to,
    location: this.location,
    item: this.item,
    description: this.description,
  });
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.error {
  color: $red;
  font-size: 10px;
}
</style>
